/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1beta2

import (
	"context"
	"time"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	scheme "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-aws/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AWSClusterRoleIdentitiesGetter has a method to return a AWSClusterRoleIdentityInterface.
// A group's client should implement this interface.
type AWSClusterRoleIdentitiesGetter interface {
	AWSClusterRoleIdentities(namespace string) AWSClusterRoleIdentityInterface
}

// AWSClusterRoleIdentityInterface has methods to work with AWSClusterRoleIdentity resources.
type AWSClusterRoleIdentityInterface interface {
	Create(ctx context.Context, aWSClusterRoleIdentity *v1beta2.AWSClusterRoleIdentity, opts v1.CreateOptions) (*v1beta2.AWSClusterRoleIdentity, error)
	Update(ctx context.Context, aWSClusterRoleIdentity *v1beta2.AWSClusterRoleIdentity, opts v1.UpdateOptions) (*v1beta2.AWSClusterRoleIdentity, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta2.AWSClusterRoleIdentity, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta2.AWSClusterRoleIdentityList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterRoleIdentity, err error)
	AWSClusterRoleIdentityExpansion
}

// aWSClusterRoleIdentities implements AWSClusterRoleIdentityInterface
type aWSClusterRoleIdentities struct {
	client rest.Interface
	ns     string
}

// newAWSClusterRoleIdentities returns a AWSClusterRoleIdentities
func newAWSClusterRoleIdentities(c *InfrastructureV1beta2Client, namespace string) *aWSClusterRoleIdentities {
	return &aWSClusterRoleIdentities{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the aWSClusterRoleIdentity, and returns the corresponding aWSClusterRoleIdentity object, and an error if there is any.
func (c *aWSClusterRoleIdentities) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSClusterRoleIdentity, err error) {
	result = &v1beta2.AWSClusterRoleIdentity{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("awsclusterroleidentities").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AWSClusterRoleIdentities that match those selectors.
func (c *aWSClusterRoleIdentities) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSClusterRoleIdentityList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta2.AWSClusterRoleIdentityList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("awsclusterroleidentities").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested aWSClusterRoleIdentities.
func (c *aWSClusterRoleIdentities) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("awsclusterroleidentities").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a aWSClusterRoleIdentity and creates it.  Returns the server's representation of the aWSClusterRoleIdentity, and an error, if there is any.
func (c *aWSClusterRoleIdentities) Create(ctx context.Context, aWSClusterRoleIdentity *v1beta2.AWSClusterRoleIdentity, opts v1.CreateOptions) (result *v1beta2.AWSClusterRoleIdentity, err error) {
	result = &v1beta2.AWSClusterRoleIdentity{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("awsclusterroleidentities").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSClusterRoleIdentity).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a aWSClusterRoleIdentity and updates it. Returns the server's representation of the aWSClusterRoleIdentity, and an error, if there is any.
func (c *aWSClusterRoleIdentities) Update(ctx context.Context, aWSClusterRoleIdentity *v1beta2.AWSClusterRoleIdentity, opts v1.UpdateOptions) (result *v1beta2.AWSClusterRoleIdentity, err error) {
	result = &v1beta2.AWSClusterRoleIdentity{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("awsclusterroleidentities").
		Name(aWSClusterRoleIdentity.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSClusterRoleIdentity).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the aWSClusterRoleIdentity and deletes it. Returns an error if one occurs.
func (c *aWSClusterRoleIdentities) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("awsclusterroleidentities").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *aWSClusterRoleIdentities) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("awsclusterroleidentities").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched aWSClusterRoleIdentity.
func (c *aWSClusterRoleIdentities) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterRoleIdentity, err error) {
	result = &v1beta2.AWSClusterRoleIdentity{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("awsclusterroleidentities").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
